PJ_Settings = {};
local st = 0;


function UpdatePetFrames()
	for i=1, 3 do
		local petID = C_PetJournal.GetPetLoadOutInfo(i)
		if petID ~= nil then
			local _, customName, level, xp, maxXP, _,_, Name, peticon  = C_PetJournal.GetPetInfoByPetID(petID);
			local health, maxHealth, _, _, rarity = C_PetJournal.GetPetStats(petID);
			local p = getglobal("pet" .. i .. "Button")
			local pb = getglobal("pet" .. i .. "Border")
			local t = getglobal("pet" .. i .. "tex")
			local n = getglobal("pet" .. i .. "name")
			local php = getglobal("pet" .. i .. "hp")
			local pxp = getglobal("pet" .. i .. "xp")
			if peticon ~= nil then
				--loadMessage:Hide()
				t:SetTexture(peticon)
				pb:SetBackdropBorderColor(ITEM_QUALITY_COLORS[rarity-1].r, ITEM_QUALITY_COLORS[rarity-1].g, ITEM_QUALITY_COLORS[rarity-1].b)
				php:SetMinMaxValues(0,maxHealth)
				php:SetValue(health)
				php.value:SetText(health.."/"..maxHealth)
				pxp:SetMinMaxValues(0,maxXP)
				pxp:SetValue(xp)
				pxp.value:SetText(xp.."/"..maxXP)
				p:Show()
				if customName ~= nil then
					n:SetText("|cFF3030FFLV. "..level.."|r "..customName)
				else
					n:SetText("|cFF3030FFLV. "..level.."|r "..Name)
				end
			end
		end
	end
end

-- Frame creation

local f = CreateFrame("Frame","PetBattleJunkieFrame")
f:SetBackdrop({
	bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
      edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", 
      tile=1, tileSize=16, edgeSize=16, 
      insets={left=4, right=4, top=4, bottom=4}	
	})
f:SetFrameStrata("LOW")
f:SetWidth(220) -- Set these to whatever height/width is needed 
f:SetHeight(138) -- for your Texture
f:SetPoint("CENTER",UIParent)
f:EnableMouse(true)
f:SetMovable(true)
f:RegisterForDrag("LeftButton")
f:SetScript("OnDragStart", function(self) self:StartMoving() end)
f:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
f:Show()

f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("PET_JOURNAL_LIST_UPDATE")
f:RegisterEvent("BATTLE_PET_CURSOR_CLEAR")
f:RegisterEvent("PET_BATTLE_OVER")
f:RegisterEvent("PET_BATTLE_OPENING_START")
f:RegisterEvent("QUEST_LOG_UPDATE")

f:SetScript("OnEvent", function (self,event,arg1)
	if (event=="PLAYER_LOGIN") then
		DEFAULT_CHAT_FRAME:AddMessage("PetJunkie loaded!")
		UpdatePetFrames()
	end
	if (event=="PET_JOURNAL_LIST_UPDATE" or event=="BATTLE_PET_CURSOR_CLEAR") then
		UpdatePetFrames()
	end
	if (event=="QUEST_LOG_UPDATE") then
		UpdatePetFrames()
		if C_PetJournal.GetPetLoadOutInfo(1) ~= nil then
			f:UnregisterEvent("QUEST_LOG_UPDATE")
		end
	end
	if (event=="PET_BATTLE_OVER") then
		UpdatePetFrames()
		PetBattleJunkieFrame:Show()
	end
	if (event=="PET_BATTLE_OPENING_START") then
		PetBattleJunkieFrame:Hide()
	end
end)



-- Pet 1 Frame
local pet1 = CreateFrame("BUTTON","pet1Button", PetBattleJunkieFrame)
pet1:SetFrameStrata("LOW")
pet1:SetWidth(32)
pet1:SetHeight(32)
	local t = pet1:CreateTexture("pet1tex","LOW")
	t:SetAllPoints(pet1)
pet1.texture = t
local n = pet1:CreateFontString("pet1name", "OVERLAY", "GameFontWhiteSmall")
n:SetPoint("TOPLEFT",pet1Button, "TOPRIGHT",10,0)
pet1:Hide()
pet1:SetPoint("TOPLEFT", PetBattleJunkieFrame, "TOPLEFT",15,-15)
local statusbar = CreateFrame("StatusBar", "pet1hp", pet1Button)
statusbar:SetPoint("TOPLEFT", pet1Button, "TOPRIGHT", 10,-10 )
statusbar:SetWidth(147)
statusbar:SetHeight(8)
statusbar:SetMinMaxValues(0,100)
statusbar:SetValue(100)
statusbar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar:GetStatusBarTexture():SetHorizTile(false)
statusbar:GetStatusBarTexture():SetVertTile(false)
statusbar:SetStatusBarColor(0, 0.65, 0)
statusbar.bg = statusbar:CreateTexture(nil, "BACKGROUND")
statusbar.bg:SetTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar.bg:SetAllPoints(true)
statusbar.bg:SetVertexColor(0, 0.35, 0)
statusbar.value = statusbar:CreateFontString(nil, "OVERLAY")
statusbar.value:SetPoint("CENTER", statusbar, "CENTER", 0, 0)
statusbar.value:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
statusbar.value:SetJustifyH("LEFT")
statusbar.value:SetShadowOffset(1, -1)
statusbar.value:SetTextColor(0, 1, 0)
local statusbar = CreateFrame("StatusBar", "pet1xp", pet1Button)
statusbar:SetPoint("TOPLEFT", pet1Button, "TOPRIGHT", 10,-20 )
statusbar:SetWidth(147)
statusbar:SetHeight(8)
statusbar:SetMinMaxValues(0,100)
statusbar:SetValue(100)
statusbar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar:GetStatusBarTexture():SetHorizTile(false)
statusbar:GetStatusBarTexture():SetVertTile(false)
statusbar:SetStatusBarColor(0, 0.39, 0.88)
statusbar.bg = statusbar:CreateTexture(nil, "BACKGROUND")
statusbar.bg:SetTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar.bg:SetAllPoints(true)
statusbar.bg:SetVertexColor(0.0, 0.2, 0.38)
statusbar.value = statusbar:CreateFontString(nil, "OVERLAY")
statusbar.value:SetPoint("CENTER", statusbar, "CENTER", 0, 0)
statusbar.value:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
statusbar.value:SetJustifyH("LEFT")
statusbar.value:SetShadowOffset(1, -1)
statusbar.value:SetTextColor(1, 1, 1)

local p1b = CreateFrame("BUTTON","pet1Border" , pet1Button)
p1b:SetFrameStrata("LOW")
p1b:SetWidth(36)
p1b:SetHeight(36)
p1b:SetBackdrop({
      --bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
      edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", 
      tile=1, tileSize=16, edgeSize=16, 
      insets={left=4, right=4, top=4, bottom=4}    
})
p1b:SetPoint("TOPLEFT",pet1Button,"TOPLEFT",-2.5,2.5)
--p1b:SetScript("OnClick", function() ChatFrame1:AddMessage("Hello World") end)
p1b:RegisterForClicks("LeftButtonUp","RightButtonUp")
p1b:SetScript("OnClick", function(self,button)
	if button == "LeftButton" then
		TogglePetJournal(2)
	end
	if button == "RightButton" then
		C_PetJournal.SummonPetByGUID(C_PetJournal.GetPetLoadOutInfo(1))
	end
end)


--Pet 2 Frame
local pet2 = CreateFrame("BUTTON","pet2Button", PetBattleJunkieFrame)
pet2:SetFrameStrata("LOW")
pet2:SetWidth(32)
pet2:SetHeight(32)
t = pet2:CreateTexture("pet2tex","LOW")
t:SetAllPoints(pet2)
pet2.texture = t
n = pet2:CreateFontString("pet2name", "OVERLAY", "GameFontWhiteSmall")
n:SetPoint("TOPLEFT",pet2Button, "TOPRIGHT",10,0)
pet2:Hide()
pet2:SetPoint("CENTER", pet1Button, "CENTER",0,-38)
local statusbar = CreateFrame("StatusBar", "pet2hp", pet2Button)
statusbar:SetPoint("TOPLEFT", pet2Button, "TOPRIGHT", 10,-10 )
statusbar:SetWidth(147)
statusbar:SetHeight(8)
statusbar:SetMinMaxValues(0,100)
statusbar:SetValue(100)
statusbar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar:GetStatusBarTexture():SetHorizTile(false)
statusbar:GetStatusBarTexture():SetVertTile(false)
statusbar:SetStatusBarColor(0, 0.65, 0)
statusbar.bg = statusbar:CreateTexture(nil, "BACKGROUND")
statusbar.bg:SetTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar.bg:SetAllPoints(true)
statusbar.bg:SetVertexColor(0, 0.35, 0)
statusbar.value = statusbar:CreateFontString(nil, "OVERLAY")
statusbar.value:SetPoint("CENTER", statusbar, "CENTER", 0, 0)
statusbar.value:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
statusbar.value:SetJustifyH("LEFT")
statusbar.value:SetShadowOffset(1, -1)
statusbar.value:SetTextColor(0, 1, 0)
local statusbar = CreateFrame("StatusBar", "pet2xp", pet2Button)
statusbar:SetPoint("TOPLEFT", pet2Button, "TOPRIGHT", 10,-20 )
statusbar:SetWidth(147)
statusbar:SetHeight(8)
statusbar:SetMinMaxValues(0,100)
statusbar:SetValue(100)
statusbar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar:GetStatusBarTexture():SetHorizTile(false)
statusbar:GetStatusBarTexture():SetVertTile(false)
statusbar:SetStatusBarColor(0, 0.39, 0.88)
statusbar.bg = statusbar:CreateTexture(nil, "BACKGROUND")
statusbar.bg:SetTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar.bg:SetAllPoints(true)
statusbar.bg:SetVertexColor(0.0, 0.2, 0.38)
statusbar.value = statusbar:CreateFontString(nil, "OVERLAY")
statusbar.value:SetPoint("CENTER", statusbar, "CENTER", 0, 0)
statusbar.value:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
statusbar.value:SetJustifyH("LEFT")
statusbar.value:SetShadowOffset(1, -1)
statusbar.value:SetTextColor(1, 1, 1)

local p2b = CreateFrame("BUTTON","pet2Border" , pet2Button)
p2b:SetFrameStrata("LOW")
p2b:SetWidth(36)
p2b:SetHeight(36)
p2b:SetBackdrop({
      --bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
      edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", 
      tile=1, tileSize=16, edgeSize=16, 
      insets={left=4, right=4, top=4, bottom=4}    
})
p2b:SetPoint("TOPLEFT",pet2Button,"TOPLEFT",-2.5,2.5)
p2b:RegisterForClicks("LeftButtonUp","RightButtonUp")
p2b:SetScript("OnClick", function(self,button)
	if button == "LeftButton" then
		TogglePetJournal(2)
	end
	if button == "RightButton" then
		C_PetJournal.SummonPetByGUID(C_PetJournal.GetPetLoadOutInfo(2))
	end
end)

--Pet 3 Frame
local pet3 = CreateFrame("BUTTON","pet3Button", PetBattleJunkieFrame)
pet3:SetFrameStrata("LOW")
pet3:SetWidth(32)
pet3:SetHeight(32)
t = pet3:CreateTexture("pet3tex","LOW")
t:SetAllPoints(pet3)
pet3.texture = t
n = pet3:CreateFontString("pet3name", "OVERLAY", "GameFontWhiteSmall")
n:SetPoint("TOPLEFT",pet3Button, "TOPRIGHT",10,0)
pet3:Hide()
pet3:SetPoint("CENTER", pet2Button, "CENTER",0,-38)
local statusbar = CreateFrame("StatusBar", "pet3hp", pet3Button)
statusbar:SetPoint("TOPLEFT", pet3Button, "TOPRIGHT", 10,-10 )
statusbar:SetWidth(147)
statusbar:SetHeight(8)
statusbar:SetMinMaxValues(0,100)
statusbar:SetValue(100)
statusbar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar:GetStatusBarTexture():SetHorizTile(false)
statusbar:GetStatusBarTexture():SetVertTile(false)
statusbar:SetStatusBarColor(0, 0.65, 0)
statusbar.bg = statusbar:CreateTexture(nil, "BACKGROUND")
statusbar.bg:SetTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar.bg:SetAllPoints(true)
statusbar.bg:SetVertexColor(0, 0.35, 0)
statusbar.value = statusbar:CreateFontString(nil, "OVERLAY")
statusbar.value:SetPoint("CENTER", statusbar, "CENTER", 0, 0)
statusbar.value:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
statusbar.value:SetJustifyH("LEFT")
statusbar.value:SetShadowOffset(1, -1)
statusbar.value:SetTextColor(0, 1, 0)
local statusbar = CreateFrame("StatusBar", "pet3xp", pet3Button)
statusbar:SetPoint("TOPLEFT", pet3Button, "TOPRIGHT", 10,-20 )
statusbar:SetWidth(147)
statusbar:SetHeight(8)
statusbar:SetMinMaxValues(0,100)
statusbar:SetValue(100)
statusbar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar:GetStatusBarTexture():SetHorizTile(false)
statusbar:GetStatusBarTexture():SetVertTile(false)
statusbar:SetStatusBarColor(0, 0.39, 0.88)
statusbar.bg = statusbar:CreateTexture(nil, "BACKGROUND")
statusbar.bg:SetTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar.bg:SetAllPoints(true)
statusbar.bg:SetVertexColor(0.0, 0.2, 0.38)
statusbar.value = statusbar:CreateFontString(nil, "OVERLAY")
statusbar.value:SetPoint("CENTER", statusbar, "CENTER", 0, 0)
statusbar.value:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
statusbar.value:SetJustifyH("LEFT")
statusbar.value:SetShadowOffset(1, -1)
statusbar.value:SetTextColor(1, 1, 1)

local p3b = CreateFrame("BUTTON","pet3Border" , pet3Button)
p3b:SetFrameStrata("LOW")
p3b:SetWidth(36)
p3b:SetHeight(36)
p3b:SetBackdrop({
      --bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
      edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", 
      tile=1, tileSize=16, edgeSize=16, 
      insets={left=4, right=4, top=4, bottom=4}    
})
p3b:SetPoint("TOPLEFT",pet3Button,"TOPLEFT",-2.5,2.5)
p3b:RegisterForClicks("LeftButtonUp","RightButtonUp")
p3b:SetScript("OnClick", function(self,button)
	if button == "LeftButton" then
		TogglePetJournal(2)
	end
	if button == "RightButton" then
		C_PetJournal.SummonPetByGUID(C_PetJournal.GetPetLoadOutInfo(3))
	end
end)